// MainFrame.cpp
#include "MainFrame.h"

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
  ON_WM_PAINT()
  ON_WM_KEYDOWN()
  ON_WM_CHAR()
END_MESSAGE_MAP()

CMainFrame::CMainFrame()
{
	Create(NULL,
           "Mensagens do Teclado",
           WS_OVERLAPPEDWINDOW &~WS_THICKFRAME, //sem resizing
           CRect(20,20,500,400));

	CenterWindow();

	mRect = CRect(40,40,440,340);
	mPt = mRect.CenterPoint();
	mStr = "aabbcc";
};

void CMainFrame::OnPaint()
{
	CPaintDC dc(this);

	dc.Rectangle(mRect);  
	dc.TextOut(mPt.x,mPt.y,mStr);
	dc.TextOut(95,10,"Utilize: Setas, Backspace e caracteres ASCII");
}

void CMainFrame::OnKeyDown(UINT nChar, UINT nRep, UINT nFlags)
{
	CClientDC dc(this);
	int iStep = 10;
	CSize szTextSize;
	CRect rcInvalidRect;

	//captura a rea da string antes dela ser modificada
	rcInvalidRect = CRect(mPt, dc.GetTextExtent(mStr));

	//Testa o estado das setas
	if (GetKeyState(VK_LEFT)<0) mPt.x = mPt.x - iStep;
	if (GetKeyState(VK_RIGHT)<0) mPt.x = mPt.x + iStep;
	if (GetKeyState(VK_UP)<0) mPt.y = mPt.y - iStep;
	if (GetKeyState(VK_DOWN)<0) mPt.y = mPt.y + iStep;		
	
	szTextSize = dc.GetTextExtent(mStr);

	//Verifica os limites de posio da string na tela
	if (mPt.x <= 40) mPt.x = 41;
	if (mPt.y <= 40) mPt.y = 41;
	if ((mPt.x + szTextSize.cx) >= 440) mPt.x = mPt.x - iStep;
	if ((mPt.y + szTextSize.cy) >= 340) mPt.y = mPt.y - iStep;
	
	//Determina o retngulo da rea invlida
	rcInvalidRect.UnionRect(rcInvalidRect, CRect(mPt, szTextSize));

	//Gera WM_PAINT
	InvalidateRect(rcInvalidRect);
}

void CMainFrame::OnChar(UINT nChar, UINT nRep, UINT nFlags)
{
	CClientDC dc(this);


	if (nChar == 8) //O cdigo ASCII do Backspace  8
	{
		mStr.Delete(mStr.GetLength()-1);
	}
	else
	{
		mStr = mStr + (char) nChar;
		CSize Size = dc.GetTextExtent(mStr);

		//Verifica o limite de posio da string na tela
		if ((mPt.x + Size.cx) >= 440)
		{
			mStr.Delete(mStr.GetLength()-1);
		}
		else 
		{
			//Determina a rea invlida e gera WM_PAINT
			InvalidateRect( CRect(mPt, dc.GetTextExtent(mStr)) ); 
		}
	}
}