// MainFrame.cpp
#include "MainFrame.h"

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
  ON_WM_PAINT()
  ON_WM_LBUTTONDOWN()
  ON_WM_LBUTTONUP()
  ON_WM_LBUTTONDBLCLK()
  ON_WM_MOUSEMOVE()  
END_MESSAGE_MAP()

CMainFrame::CMainFrame()
{
	Create(NULL,
           "Trabalhando com o Mouse",
           WS_OVERLAPPEDWINDOW,
           CRect(20,20,500,400));

	CenterWindow();

	hCross = AfxGetApp()->LoadStandardCursor(IDC_CROSS);
	hArrow = AfxGetApp()->LoadStandardCursor(IDC_ARROW);

	mRect.SetRectEmpty();
	mStrPoint = CPoint(0,0);
	mStr = "abcd";
	bNewRect = FALSE;
};

void CMainFrame::OnPaint()
{
	CPaintDC dc(this);

	if (mRect.PtInRect(mStrPoint)) 
	{
		dc.TextOut(mStrPoint.x, mStrPoint.y, mStr);
		dc.SelectStockObject(NULL_BRUSH);
	}		
	dc.Rectangle(mRect);		
}

void CMainFrame::OnLButtonDown(UINT nFlags, CPoint point)
{
	if (!mRect.PtInRect(point))
	{
		mStartPoint = point;
		SetCapture();
		bNewRect = TRUE;	
	}
	else SetCursor(hCross);
}

void CMainFrame::OnLButtonUp(UINT nFlags, CPoint point)
{
	if (bNewRect)
	{
		mEndPoint = point;
		mRect = CRect(mStartPoint, mEndPoint);
		mRect.NormalizeRect();
		bNewRect = FALSE;

		Invalidate();
		ReleaseCapture();		
	}
	if (mRect.PtInRect(point)) SetCursor(hCross);	
}

void CMainFrame::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	if (mRect.PtInRect(point))
	{
		mStrPoint = point;
		SetCursor(hCross);
		Invalidate();
	}
}

void CMainFrame::OnMouseMove(UINT nFlags, CPoint point)
{
	BOOL bMouseOut = FALSE;
	
	if (nFlags & MK_SHIFT)
	{
		if (point.x > mRect.right)
		{
			point.x = mRect.right - 1;
			bMouseOut = TRUE;
		}
		if (point.x < mRect.left)
		{
			point.x = mRect.left;
			bMouseOut = TRUE;
		}
		if (point.y > mRect.bottom)
		{
			point.y = mRect.bottom -1;
			bMouseOut = TRUE;
		}
		if (point.y < mRect.top)
		{
			point.y = mRect.top;
			bMouseOut = TRUE;
		}
		if (bMouseOut && (!mRect.IsRectEmpty()))
		{
			ClientToScreen(&point);
			SetCursorPos(point.x, point.y);
		}
	}
	if (mRect.PtInRect(point)) SetCursor(hCross);
		else SetCursor(hArrow);
}

