// MainFrame.CPP
#include "MainFrame.h"

#define IDC_BTN_CALC		 300
#define IDC_BTN_GROUP		 301
#define IDC_BTN_METERS		 302	
#define IDC_BTN_KILOMETERS	 303
#define IDC_STC_WIDTH		 310
#define IDC_EDT_WIDTH		 311
#define IDC_STC_LENGTH		 320
#define IDC_EDT_LENGTH		 321
#define IDC_STC_AREA		 330
#define IDC_STC_RESULT		 331
 
BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
    // Mensagens de notificao
    ON_BN_CLICKED  (IDC_BTN_CALC,    OnClickCalc)
	ON_BN_CLICKED  (IDC_BTN_METERS,    OnClickMeters)
	ON_BN_CLICKED  (IDC_BTN_KILOMETERS,    OnClickKilometers)
    ON_EN_SETFOCUS (IDC_EDT_LENGTH,  OnLengthFocus)
    ON_EN_KILLFOCUS(IDC_EDT_LENGTH,  OnLengthKillFocus)
    ON_EN_CHANGE   (IDC_EDT_WIDTH,   OnWidthChange)
END_MESSAGE_MAP()

CMainFrame::CMainFrame()
{ 
  //Criao da janela principal
  Create(NULL, "Window Controls",
                WS_OVERLAPPEDWINDOW,
                CRect(0,0,505,150));

  //Criao dos controles
  stcLength.Create  ("Comprimento (m)",
                     WS_CHILD |WS_VISIBLE | SS_CENTER, 
                     CRect(CPoint(10,10),CSize(120,25)), 
                     this, IDC_STC_LENGTH);

  stcWidth.Create  ("Largura (m)",
                     WS_CHILD | WS_VISIBLE | SS_CENTER, 
                     CRect(CPoint(140,10),CSize(100,25)), 
                     this, IDC_STC_WIDTH);

  stcArea.Create   ("rea (m2)",
                     WS_CHILD | WS_VISIBLE | SS_CENTER, 
                     CRect(CPoint(250,10),CSize(120,25)), 
                     this, IDC_STC_AREA);

  stcResult.Create ("",
                     WS_CHILD | WS_VISIBLE | SS_SUNKEN | SS_CENTER, 
                     CRect(CPoint(250,50),CSize(120,25)), 
                     this, IDC_STC_RESULT);
  
  edtLength.Create (WS_CHILD | WS_VISIBLE | WS_BORDER, 
                     CRect(CPoint(10,50),CSize(120,25)),
                     this, IDC_EDT_LENGTH);
    
  edtWidth.Create  (WS_CHILD | WS_VISIBLE | WS_BORDER, 
                     CRect(CPoint(140,50),CSize(100,25)), 
                     this, IDC_EDT_WIDTH);

  btnGroup.Create("Unidade", 
					 WS_CHILD | WS_VISIBLE | BS_GROUPBOX,
					 CRect(CPoint(380,2),CSize(105,75)),
					 this, IDC_BTN_GROUP);

  btnMeters.Create("Metros",
					 WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON | WS_GROUP,
					 CRect(CPoint(385,22),CSize(95,25)),
					 this, IDC_BTN_METERS);

  btnKilometers.Create("Quilmetros",
					 WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON,
					 CRect(CPoint(385,46),CSize(95,25)),
					 this, IDC_BTN_KILOMETERS);
					 
  btnCalc.Create ("Calcular a rea",
                     WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
                     CRect(CPoint(90,85),CSize(200,25)),
                     this, IDC_BTN_CALC);

  CheckRadioButton(IDC_BTN_METERS,IDC_BTN_KILOMETERS,IDC_BTN_METERS);

  edtLength.SetFocus();  //D o foco para o primeiro CEdit
}

void CMainFrame::OnClickCalc()
{
  CString str;
  edtLength.GetWindowText(str);
  double length = atof(str);

  edtWidth.GetWindowText(str);
  double width = atof(str);

  double area = length * width;
  str.Format("%f", area);
  stcResult.SetWindowText(str);
}

void CMainFrame::OnClickMeters()
{
  stcLength.SetWindowText("Comprimento (m)");
  stcWidth.SetWindowText("Largura (m)");
  stcArea.SetWindowText("rea (m2)");
}

void CMainFrame::OnClickKilometers()
{
  stcLength.SetWindowText("Comprimento (Km)");
  stcWidth.SetWindowText("Largura (Km)");
  stcArea.SetWindowText("rea (Km2)");
}

void CMainFrame::OnLengthFocus()
{
  edtLength.SetWindowText("");
  stcResult.SetWindowText("");
}

void CMainFrame::OnLengthKillFocus()
{
  // Testa a validade dos dados
  CString str;
  edtLength.GetWindowText(str);
  if (atof(str) < 0)
  {
    MessageBox ("Valor invlido");
    edtLength.SetWindowText ("");
    edtLength.SetFocus();
  }
}

void CMainFrame::OnWidthChange()
{
  CString str;
  edtLength.GetWindowText(str);
  double length = atof(str);

  edtWidth.GetWindowText(str);
  double width = atof(str);

  double area = length * width;
  str.Format("%f", area);
  stcResult.SetWindowText(str);
}