// MainFrame.cpp
#include "MainFrame.h"

#define DRAWING 1
#define SELECTING 2

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
  ON_WM_PAINT()
  ON_WM_LBUTTONDOWN()  
  ON_WM_MOUSEMOVE()  
  ON_WM_LBUTTONUP()
END_MESSAGE_MAP()

CMainFrame::CMainFrame()
{
	Create(NULL,
           "Caixas Elsticas",
           WS_OVERLAPPEDWINDOW,
           CRect(20,20,500,400));

	CenterWindow();

	//cria as penas de desenho diferentes da pena padro
	penRectangle.CreatePen(PS_SOLID, 1, RGB(125,125,125));
	penSelection.CreatePen(PS_SOLID, 2, RGB(255,0,0));

	iAction = DRAWING;

	iPoints = 0;
};

void CMainFrame::OnPaint()
{
	CPaintDC dc(this);

	if (iPoints <= 1) return;

	dc.Polyline(ptsShape, iPoints);		
}

void CMainFrame::OnLButtonDown(UINT nFlags, CPoint point)
{
	if (nFlags & MK_SHIFT)
	{
		iAction = SELECTING;
		mStartPoint = point;
		mSelectionRect = CRect(point,point);
		SetCapture();
	}
	else
	{
		iAction = DRAWING;
		if (iPoints < 99) //vetor cheio
		{
			ptsShape[iPoints] = point;
			iPoints++;
			Invalidate();
		}		
	}
}

void CMainFrame::OnMouseMove(UINT nFlags, CPoint point)
{
	CRect rClientRect;
	CClientDC dc(this);

	if (iAction == DRAWING) return;

	//apaga o retngulo anterior
	dc.SetROP2(R2_XORPEN);
	dc.SelectObject(&penRectangle);
	dc.SelectStockObject(NULL_BRUSH);
	dc.Rectangle(mSelectionRect);

	//gera o novo retngulo dentro dos limites da janela
	GetClientRect(&rClientRect);
	if (point.x > rClientRect.right) mEndPoint.x = rClientRect.right;
	else if (point.x < rClientRect.left) mEndPoint.x = rClientRect.left;
	else mEndPoint.x = point.x;

	if (point.y > rClientRect.bottom) mEndPoint.y = rClientRect.bottom;
	else if (point.y < rClientRect.top) mEndPoint.y = rClientRect.top;
	else mEndPoint.y = point.y;

	mSelectionRect = CRect(mStartPoint, mEndPoint);
	mSelectionRect.NormalizeRect();

	//desenha o novo retngulo
	dc.Rectangle(mSelectionRect);
}

void CMainFrame::OnLButtonUp(UINT nFlags, CPoint point)
{
	CClientDC dc(this);
	int cont;
	CPoint ptFirst, ptSecond;

	if (iAction == DRAWING) return;
	
	//apaga a caixa elstica
	dc.SetROP2(R2_XORPEN);
	dc.SelectObject(&penRectangle);
	dc.SelectStockObject(NULL_BRUSH);
	dc.Rectangle(mSelectionRect);	
	
	ReleaseCapture();
	iAction = DRAWING;

	//Desenha os segmentos de reta contidos na caixa de seleo
	if (iPoints <= 1) return;	
	cont = 0;
	dc.SetROP2(R2_COPYPEN);
	dc.SelectObject(&penSelection);	
	while(cont < iPoints)
	{
		ptFirst = ptsShape[cont];
		ptSecond = ptsShape[cont+1];

		if (mSelectionRect.PtInRect(ptFirst) & mSelectionRect.PtInRect(ptSecond))
		{
			dc.MoveTo(ptFirst);
			dc.LineTo(ptSecond);
		}
		cont++;
	}
}